/*  Copyright (C) 2000, 2006  Marc Toussaint (mtoussai@inf.ed.ac.uk)
    under the terms of the GNU LGPL (http://www.gnu.org/copyleft/lesser.html)
    see the `std.h' file for a full copyright statement  */

#ifndef MT_functions_h
#define MT_functions_h

#include "array.h"

#define EXP ::exp //MT::approxExp

double NNsdv(const double& a,const double& b,double sdv);
double NNsdv(double x,double sdv);
double NNinv(const doubleA& a,const doubleA& b,const doubleA& invC);
double logNNinv(const doubleA& a,const doubleA& b,const doubleA& invC);
double NN(const doubleA& a,const doubleA& b,const doubleA& C);

//! non-normalized!! Gaussian function (f(0)=1)
double NNNNinv(const doubleA& a,const doubleA& b,const doubleA& invC);
double NNNN(const doubleA& a,const doubleA& b,const doubleA& C);
double NNzeroinv(const doubleA& x,const doubleA& invC);
//! gradient of a Gaussian
double dNNinv(const doubleA& x,const doubleA& a,const doubleA& invA,doubleA& grad);
//! gradient of a non-normalized Gaussian
double dNNNNinv(const doubleA& x,const doubleA& a,const doubleA& invA,doubleA& grad);
double NNsdv(const doubleA& a,const doubleA& b,double sdv);
double NNzerosdv(const doubleA& x,double sdv);

#ifdef MT_IMPLEMENTATION
#  include "functions.cpp"
#endif

#endif
