#include "geo3d.h"

/*void geo3d::Trimesh::getOBJ(char* filename){
  if (!glm){
  glm = glmReadOBJ(filename);
  glmReverseWinding(glm);
  }
  
  ////glmUnitize(glm);
  glmFacetNormals(glm);
  glmVertexNormals(glm, 90.0);
  
  // creates a display list for the OBJ
  ////	g._pmodel_displaylist = glmList(glm, GLM_SMOOTH | GLM_MATERIAL);
  }*/

// dm 07.06.2006
/*!\ initialises the ascii-obj file "filename"*/
void geo3d::Trimesh::readOBJ(char* filename){
  FILE* file;
  
  // open the file 
  file = fopen(filename, "r");
  if (!file) {
    fprintf(stderr, "readOBJ() failed: can't open data file \"%s\".\n",
	    filename);
    exit(1);
  }
  else {
    printf("%s opened.\n ", filename);
  }
  // allocate a new model
  //	pathname = strdup(filename);
  
  numvertices = 0;
  numtriangles = 0;
  numnormals = 0;
  numfacenormals = 0;
  numtexcoords = 0;
  //position.setZero();
  
  // make a first pass through the file to get a count of the number
  // of vertices, normals, texcoords & triangles 
  firstPass(file);
  
  
  // allocate memory 
  V.resize(numvertices); // eventually add this: (GLfloat*)malloc(sizeof(GLfloat) * 3
  T.resize(numtriangles); //eventually add this : (GLMtriangle*)malloc(sizeof(GLMtriangle) *
  if (numnormals)
    {
      Vn.resize(numnormals); //// eventually add this: (GLfloat*)malloc(sizeof(GLfloat) * 3
    }
  if (numtexcoords)
    {
      Tex = (double*)malloc(sizeof(double) * 2 * (numtexcoords));
    }
  
  // rewind to beginning of file and read in the data this pass 
  rewind(file);
  
  secondPass(file);
  
  // close the file 
  fclose(file);
  
}


/*!\First pass at a Wavefront OBJ file that gets all the
  statistics of the model (such as #vertices, #normals, etc)

  file  - (fopen'd) file descriptor 
*/
void geo3d::Trimesh::firstPass(FILE* file){
  uint _numvertices;        
  uint _numnormals;        
  uint _numtexcoords;       
  uint _numtriangles;       
  ////    GLMgroup* group;           // current group 
  int v, n, t;
  char buf[128];
  
  /* make a default group */
  /*   group = glmAddGroup(model, "default");*/
  
  _numvertices = _numnormals = _numtexcoords = _numtriangles = 0;
  while(fscanf(file, "%s", buf) != EOF) {
    switch(buf[0]) {
    case '#':               // comment
      // eat up rest of line 
      fgets(buf, sizeof(buf), file);
      break;
    case 'v':               // v, vn, vt 
      switch(buf[1]) {
      case '\0':          // vertex 
	// eat up rest of line 
	fgets(buf, sizeof(buf), file);
	_numvertices++;
	break;
      case 'n':           // normal 
	// eat up rest of line 
	fgets(buf, sizeof(buf), file);
	_numnormals++;
	break;
      case 't':           // texcoord 
	// eat up rest of line 
	fgets(buf, sizeof(buf), file);
	_numtexcoords++;
	break;
      default:
	printf("firstPass(): Unknown token \"%s\".\n", buf);
	exit(1);
	break;
      }
      break;
    case 'm':
      // TODO: implement mat
      /*fgets(buf, sizeof(buf), file);
	sscanf(buf, "%s %s", buf, buf);
	mtllibname = strdup(buf);
	glmReadMTL(model, buf);*/
      break;
    case 'u':
      // eat up rest of line 
      fgets(buf, sizeof(buf), file);
      break;
    case 'g':               // group 
      // eat up rest of line 
      fgets(buf, sizeof(buf), file);
#if SINGLE_STRING_GROUP_NAMES
      sscanf(buf, "%s", buf);
#else
      buf[strlen(buf)-1] = '\0';  //nuke '\n' 
#endif
      ////group = glmAddGroup(model, buf);
      break;
    case 'f':               // face 
      v = n = t = 0;
      fscanf(file, "%s", buf);
      // can be one of %d, %d//%d, %d/%d, %d/%d/%d %d//%d 
      if (strstr(buf, "//")) {
	// v//n 
	sscanf(buf, "%d//%d", &v, &n);
	fscanf(file, "%d//%d", &v, &n);
	fscanf(file, "%d//%d", &v, &n);
	_numtriangles++;
	//// group->numtriangles++;
	while(fscanf(file, "%d//%d", &v, &n) > 0) {
	  _numtriangles++;
	  ////group->numtriangles++;
	}
      } else if (sscanf(buf, "%d/%d/%d", &v, &t, &n) == 3) {
	// v/t/n 
	fscanf(file, "%d/%d/%d", &v, &t, &n);
	fscanf(file, "%d/%d/%d", &v, &t, &n);
	_numtriangles++;
	//// group->numtriangles++;
	while(fscanf(file, "%d/%d/%d", &v, &t, &n) > 0) {
	  _numtriangles++;
	  //// group->numtriangles++;
	}
      } else if (sscanf(buf, "%d/%d", &v, &t) == 2) {
	// v/t 
	fscanf(file, "%d/%d", &v, &t);
	fscanf(file, "%d/%d", &v, &t);
	_numtriangles++;
	////group->numtriangles++;
	while(fscanf(file, "%d/%d", &v, &t) > 0) {
	  _numtriangles++;
	  ////group->numtriangles++;
	}
      } else {
	// v 
	fscanf(file, "%d", &v);
	fscanf(file, "%d", &v);
	_numtriangles++;
	////group->numtriangles++;
	while(fscanf(file, "%d", &v) > 0) {
	  _numtriangles++;
	  ////group->numtriangles++;
	}
      }
      break;
	
    default:
      // eat up rest of line 
      fgets(buf, sizeof(buf), file);
      break;
    }
  }
    
  // set the stats in the model structure
  numvertices  = _numvertices;
  numnormals   = _numnormals;
  //// numtexcoords = _numtexcoords;
  numtriangles = _numtriangles;
  //printf("numtriangles = %d\n",numtriangles);
}
  
  
/*!\glmSecondPass: second pass at a Wavefront OBJ file that gets all
  the data.
  
  file  - (fopen'd) file descriptor 
*/
void geo3d::Trimesh::secondPass( FILE* file) 
{
  uint _numvertices;        /* number of vertices in model */
  uint _numnormals;         /* number of normals in model */
  uint _numtexcoords;       /* number of texcoords in model */
  uint _numtriangles;       /* number of triangles in model */
  int v, n, t;
  char buf[128];
  double tempX,tempY,tempZ;
  geo3d::Vector tempV, tempN, tempD;
      
  /* on the second pass through the file, read all the data into the
     allocated arrays */
  _numvertices = _numnormals = _numtexcoords = _numtriangles = 0; //changed from 1 to 0, Sep 1 06 (mt)
  ////_material = 0;
  while(fscanf(file, "%s", buf) != EOF) {
	
    switch(buf[0]) {
    case '#':               // comment 
      // eat up rest of line /
      fgets(buf, sizeof(buf), file);
      break;
    case 'v':               // v, vn, vt 
      switch(buf[1]) {
      case '\0':          // vertex 
	fscanf(file, "%lf %lf %lf", &tempX,&tempY,&tempZ);
	tempD[0]=tempX;
	tempD[1]=tempY;
	tempD[2]=tempZ;
	V(_numvertices)=tempD;
	    
	_numvertices++;
	break;
      case 'n':           // normal 
	fscanf(file, "%lf %lf %lf", &tempX,&tempY,&tempZ);
	tempD[0]=tempX;
	tempD[1]=tempY;
	tempD[2]=tempZ;
	Vn(_numnormals)=tempD;
	    
	_numnormals++;
	break;
      case 't':           // texcoord 
	/*    fscanf(file, "%f %f", 
	      &texcoords[2 * numtexcoords + 0],
	      &texcoords[2 * numtexcoords + 1]);
	      numtexcoords++;*/
	break;
      }
      break;
    case 'u':
      /* fgets(buf, sizeof(buf), file);
	 sscanf(buf, "%s %s", buf, buf);
	 group->material = material = glmFindMaterial(model, buf);*/
      break;
    case 'g':               // group 
      // eat up rest of line 
      fgets(buf, sizeof(buf), file);
#if SINGLE_STRING_GROUP_NAMES
      sscanf(buf, "%s", buf);
#else
      buf[strlen(buf)-1] = '\0';  // nuke '\n' 
#endif
      ////  group = glmFindGroup(model, buf);
      ////  group->material = material;
      break;
    case 'f':               // face 
      v = n = t = 0;
      fscanf(file, "%s", buf);
      //can be one of %d, %d//%d, %d/%d, %d/%d/%d %d//%d 
      if (strstr(buf, "//")) {
	// v//n 
	sscanf(buf, "%d//%d", &v, &n);

	Tvi(_numtriangles,0) = v < 0 ? v + _numvertices : v;
	Tni(_numtriangles,0) = n < 0 ? n + _numnormals : n;
	fscanf(file, "%d//%d", &v, &n);
	Tvi(_numtriangles,1) = v < 0 ? v + _numvertices : v;
	Tni(_numtriangles,1) = n < 0 ? n + _numnormals : n;
	fscanf(file, "%d//%d", &v, &n);
	Tvi(_numtriangles,2) = v < 0 ? v + _numvertices : v;
	Tni(_numtriangles,2) = n < 0 ? n + _numnormals : n;
	//// group->triangles[group->_numtriangles++] = _numtriangles;
	_numtriangles++;
	while(fscanf(file, "%d//%d", &v, &n) > 0) {
	  Tvi(_numtriangles,0) = Tvi(_numtriangles-1,0);
	  Tni(_numtriangles,0) = Tni(_numtriangles-1,0);
	  Tvi(_numtriangles,1) = Tvi(_numtriangles-1,2);
	  Tni(_numtriangles,1) = Tni(_numtriangles-1,2);
	  Tvi(_numtriangles,2) = v < 0 ? v + _numvertices : v;
	  Tni(_numtriangles,2) = n < 0 ? n + _numnormals : n;
	  //// group->triangles[group->numtriangles++] = numtriangles;
	  _numtriangles++;
	}
      } else if (sscanf(buf, "%d/%d/%d", &v, &t, &n) == 3) {
	// v/t/n 
	Tvi(_numtriangles,0) = v < 0 ? v + _numvertices : v;
	Tti(_numtriangles,0) = t < 0 ? t + _numtexcoords : t;
	Tni(_numtriangles,0) = n < 0 ? n + _numnormals : n;
	fscanf(file, "%d/%d/%d", &v, &t, &n);
	Tvi(_numtriangles,1) = v < 0 ? v + _numvertices : v;
	Tti(_numtriangles,1) = t < 0 ? t + _numtexcoords : t;
	Tni(_numtriangles,1) = n < 0 ? n + _numnormals : n;
	fscanf(file, "%d/%d/%d", &v, &t, &n);
	Tvi(_numtriangles,2) = v < 0 ? v + _numvertices : v;
	Tti(_numtriangles,2) = t < 0 ? t + _numtexcoords : t;
	Tni(_numtriangles,2) = n < 0 ? n + _numnormals : n;
	//// group->triangles[group->numtriangles++] = numtriangles;
	_numtriangles++;
	while(fscanf(file, "%d/%d/%d", &v, &t, &n) > 0) {
	  Tvi(_numtriangles,0) = Tvi(_numtriangles-1,0);
	  Tti(_numtriangles,0) = Tti(_numtriangles-1,0);
	  Tni(_numtriangles,0) = Tni(_numtriangles-1,0);
	  Tvi(_numtriangles,1) = Tvi(_numtriangles-1,2);
	  Tti(_numtriangles,1) = Tti(_numtriangles-1,2);
	  Tni(_numtriangles,1) = Tni(_numtriangles-1,2);
	  Tvi(_numtriangles,2) = v < 0 ? v + _numvertices : v;
	  Tti(_numtriangles,2) = t < 0 ? t + _numtexcoords : t;
	  Tni(_numtriangles,2) = n < 0 ? n + _numnormals : n;
	  //// group->triangles[group->numtriangles++] = numtriangles;
	  _numtriangles++;
	}
      } else if (sscanf(buf, "%d/%d", &v, &t) == 2) {
	// v/t 
	      
	Tvi(_numtriangles,0) = v < 0 ? v + _numvertices : v;
	Tti(_numtriangles,0) = t < 0 ? t + _numtexcoords : t;
	fscanf(file, "%d/%d", &v, &t);
	Tvi(_numtriangles,1) = v < 0 ? v + _numvertices : v;
	Tti(_numtriangles,1) = t < 0 ? t + _numtexcoords : t;
	fscanf(file, "%d/%d", &v, &t);
	Tvi(_numtriangles,2) = v < 0 ? v + _numvertices : v;
	Tti(_numtriangles,2) = t < 0 ? t + _numtexcoords : t;
	//// group->triangles[group->numtriangles++] = numtriangles;
	_numtriangles++;
	while(fscanf(file, "%d/%d", &v, &t) > 0) {
	  Tvi(_numtriangles,0) = Tvi(_numtriangles-1,0);
	  Tti(_numtriangles,0) = Tti(_numtriangles-1,0);
	  Tvi(_numtriangles,1) = Tvi(_numtriangles-1,2);
	  Tti(_numtriangles,1) = Tti(_numtriangles-1,2);
	  Tvi(_numtriangles,2) = v < 0 ? v + _numvertices : v;
	  Tti(_numtriangles,2) = t < 0 ? t + _numtexcoords : t;
	  //// group->triangles[group->numtriangles++] = numtriangles;
	  _numtriangles++;
	}
      } else {
	// v 
	sscanf(buf, "%d", &v);
	Tvi(_numtriangles,0) = v < 0 ? v + _numvertices : v;
	fscanf(file, "%d", &v);
	Tvi(_numtriangles,1) = v < 0 ? v + _numvertices : v;
	fscanf(file, "%d", &v);
	Tvi(_numtriangles,2) = v < 0 ? v + _numvertices : v;
	//// group->triangles[group->numtriangles++] = _numtriangles;
	_numtriangles++; // fixed bug, 21. Jun 06 (hh)
	while(fscanf(file, "%d", &v) > 0) {
	  Tvi(_numtriangles,0) = Tvi(_numtriangles-1,0);
	  Tvi(_numtriangles,1) = Tvi(_numtriangles-1,2);
	  Tvi(_numtriangles,2) = v < 0 ? v + _numvertices : v;
	  //// group->triangles[group->numtriangles++] = numtriangles;
	  _numtriangles++;
	}
      }
      break;
	    
    default:
      // eat up rest of line 
      fgets(buf, sizeof(buf), file);
      break;
    }
  }
  //Sep 1, 06 (mt): start counting indices from 0
  uint i;
  for(i=0;i<T.N;i++){
    Tvi(i,0)--; Tvi(i,1)--; Tvi(i,2)--;
    Tni(i,0)--; Tni(i,1)--; Tni(i,2)--;
    Tti(i,0)--; Tti(i,1)--; Tti(i,2)--;
  }

}
  
void geo3d::Trimesh::clear()
{
  V.resize(0); Vn.resize(0); T.resize(0); T.resize(0); C.resize(0); strips.resize(0);
}
  
/*!\brief calculate the normals of all triangles (Tn) and the average
  normals of the vertices (Vn); average normals are averaged over
  all adjacent triangles that are in the triangle list or member of
  a strip */
void geo3d::Trimesh::calcNormals()
{
  uint i;
  Vector a,b,c;
  a.setZero();
  Vn.resize(V.N);
  Vn=a;
  Tn.resize(T.d0);
  //triangle normals and contributions    
  for(i=0;i<T.d0;i++){      
    a=V(Tvi(i,0)); b=V(Tvi(i,1)); c=V(Tvi(i,2));
    b-=a; c-=a; a=c^b; a.normalize();
    Tn(i)=a;
    //add the triangle's normal to each vertex normal
    // dm 21.06.2006: Removed because not used and caused crash: 
    Vn(Tvi(i,0))+=a; Vn(Tvi(i,1))+=a; Vn(Tvi(i,2))+=a;
  }
  // dm 21.06.2006: Removed because not used and caused crash: 
  for(i=0;i<Vn.N;i++) Vn(i).normalize();    
}
  
  
/* glmVertexNormals: Generates smooth vertex normals for a model.
 * First builds a list of all the triangles each vertex is in.   Then
 * loops through each vertex in the the list averaging all the facet
 * normals of the triangles each vertex is in.   Finally, sets the
 * normal index in the triangle for the vertex to the generated smooth
 * normal.   If the dot product of a facet normal and the facet normal
 * associated with the first triangle in the list of triangles the
 * current vertex is in is greater than the cosine of the angle
 * parameter to the function, that facet normal is not added into the
 * average normal calculation and the corresponding vertex is given
 * the facet normal.  This tends to preserve hard edges.  The angle to
 * use depends on the model, but 90 degrees is usually a good start.
 *
 * model - initialized GLMmodel structure
 * angle - maximum angle (in degrees) to smooth across
 */
  
  
  
void geo3d::Trimesh::calcVertexNormals(float angle)
{
  uint i, j;
  Vector tempVerNormal;
    
  // for each wertex
  for(i=0;i<numvertices;i++)
    {   
      tempVerNormal = 0.0; // reset
      // find all triangle notmals with this vertex in it
      for(j=0;j<numtriangles;j++)
	{
	
	
	  if (Tvi(j,0)==j) 
	    {	
	      tempVerNormal = tempVerNormal + Vn(Tvi(j,0));
	    }
	  else if (Tvi(j,1)==j)
	    {
	      tempVerNormal = tempVerNormal +  Vn(Tvi(j,1));
	    }
	  else if (Tvi(j,2)==j)
	    {
	      tempVerNormal = tempVerNormal +  Vn(Tvi(j,2));
	    }
	  else
	    {
	      tempVerNormal = tempVerNormal +  Vn(j);
	  
	    }
	
	
	
	
	}   
      tempVerNormal.normalize();
      
      
      
      
    }
  Vn(i) = tempVerNormal;
}
  
  
  
  
  
  
  
  
/*!\brief add triangles according to the given grid; grid has to be a 2D
  Array, the elements of which are indices referring to vertices in
  the vertex list (V) */
void geo3d::Trimesh::gridToTriangles(const uintA &grid){
  uint i,j,k=T.d0;
  T.resizeCopy(T.d0+2*(grid.d0-1)*(grid.d1-1));
  for(i=0;i<grid.d0-1;i++) for(j=0;j<grid.d1-1;j++){
    if((i+j)&1){
      Tvi(k,0)=grid(i+1,j  );
      Tvi(k,1)=grid(i  ,j  );
      Tvi(k,2)=grid(i  ,j+1);
      k++;
      Tvi(k,0)=grid(i+1,j  );
      Tvi(k,1)=grid(i  ,j+1);
      Tvi(k,2)=grid(i+1,j+1);
      k++;
    }else{
      Tvi(k,0)=grid(i+1,j  );
      Tvi(k,1)=grid(i  ,j  );
      Tvi(k,2)=grid(i+1,j+1);
      k++;
      Tvi(k,0)=grid(i+1,j+1);
      Tvi(k,1)=grid(i  ,j  );
      Tvi(k,2)=grid(i  ,j+1);
      k++;
    }
  }
}
  
/*!\brief add strips according to the given grid (sliced in strips along
  the x-axis (the first index)); grid has to be a 2D Array, the
  elements of which are indices referring to vertices in the vertex
  list (V) */
void geo3d::Trimesh::gridToStrips(const uintA& grid){
  CHECK(grid.d0>1 && grid.d1>1,"grid has to be at least 2x2");
  uint i,j,k=strips.N,l;
  strips.resizeCopy(strips.N+grid.d0-1);
  for(i=0;i<grid.d0-1;i++){
    strips(k).resize(2*grid.d1);
    l=0;
    for(j=0;j<grid.d1;j++){
      strips(k)(l)=grid(i+1,j); l++;
      strips(k)(l)=grid(i  ,j); l++;
    }
#if 0 //code to make it less symmetric
      //}else{
    strips(k)(l)=grid(i,0); l++;
    for(j=0;j<grid.d1;j++){
      strips(k)(l)=grid(i  ,j); l++;
      strips(k)(l)=grid(i+1,j); l++;
    }
#endif
    k++;
  }
}
  
/*!\brief add strips according to the given grid (sliced in strips along
  the x-axis (the first index)); it is assumed that the vertices in
  the list V linearly correspond to points in the XxY grid */
void geo3d::Trimesh::gridToStrips(uint X,uint Y){
  CHECK(X>1 && Y>1,"grid has to be at least 2x2");
  uint i,j,k=strips.N,l;
  strips.resizeCopy(strips.N+Y-1);
  for(j=0;j<Y-1;j++){
    strips(k).resize(2*X);
    l=0;
    for(i=0;i<X;i++){
      strips(k)(l)=(j+1)*X+i;
      l++;
      strips(k)(l)=    j*X+i;
      l++;
    }
    k++;
  }
}
  
/*!\brief add triangles according to the given grid; grid has to be a 2D
  Array, the elements of which are indices referring to vertices in
  the vertex list (V) */
void geo3d::Trimesh::gridToTriangles(uint X,uint Y){
  CHECK(X>1 && Y>1,"grid has to be at least 2x2");
  uint i,j,k=T.d0;
  T.resizeCopy(T.d0+(Y-1)*2*(X-1));
  for(j=0;j<Y-1;j++){
    for(i=0;i<X-1;i++){
      Tvi(k,0)=j*X+i; Tvi(k,1)=(j+1)*X+i; Tvi(k,2)=(j+1)*X+(i+1);
      k++;
      Tvi(k,0)=j*X+i; Tvi(k,1)=(j+1)*X+(i+1); Tvi(k,2)=j*X+(i+1);
      k++;
    }
  }
}
  
/*!\brief delete all void triangles (with vertex indices (0,0,0)) and void
  vertices (not used for triangles or strips) */
void geo3d::Trimesh::deleteUnused(){
  if(!V.N) return;
  MT::Permutation p;
  MT::Array<bool> u;
  MT::Array<uint> newT;
  MT::Array<Vector> newV;
  uint i,j,Nused;
  //find proper permutation of triangles
  p.init(T.d0);
  j=p.N-1;
  for(i=0;i<=j;i++) if(!(Tvi(i,0)|Tvi(i,1)|Tvi(i,2))){ p.permute(i,j); j--; break; }
  Nused=j+1;
  //permute triangle list
  newT.resize(Nused,3);
  for(i=0;i<Nused;i++){ newT(i,0)=Tvi(p(i),0); newT(i,1)=Tvi(p(i),1); newT(i,2)=Tvi(p(i),2); }
  T.resize(Nused);
  for(i=0;i<Nused;i++){ Tvi(i,0)=newT(i,0); Tvi(i,1)=newT(i,1); Tvi(i,2)=newT(i,2); }
  //mark used vertices
  u.resize(V.N);
  u=false;
  for(i=0;i<T.d0;i++){ u(Tvi(i,0))=true; u(Tvi(i,1))=true; u(Tvi(i,2))=true; }
  for(i=0;i<strips.N;i++) for(j=0;j<strips(i).N;j++) u(strips(i)(j))=true;
  //find proper permutation
  p.init(V.N);
  j=p.N-1;
  for(i=0;i<j;i++) if(!u(i)){ p.permute(i,j); j--; }
  Nused=j+1;
  //permute vertices and triangles/strips indices
  newV.resize(Nused);
  for(i=0;i<V.N;i++) if(p(i)<Nused) newV(p(i))=V(i);
  for(i=0;i<T.d0;i++){ Tvi(i,0)=p(Tvi(i,0)); Tvi(i,1)=p(Tvi(i,1)); Tvi(i,2)=p(Tvi(i,2)); }
  for(i=0;i<strips.N;i++) for(j=0;j<strips(i).N;j++) strips(i)(j)=p(strips(i)(j));
  //reassign vertex array
  V=newV;
}
  
#ifdef MT_GL
//! internal draw routine for OpenGL
void geo3d::Trimesh::glDraw(){
#if 0 //use OpenGL's Arrays for fast drawing...
  uint j;
  glEnableClientState(GL_VERTEX_ARRAY);
  glEnableClientState(GL_COLOR_ARRAY);
  //glEnableClientState(GL_NORMAL_ARRAY);
  glVertexPointer(3,GL_DOUBLE,0,V.p);
  glColorPointer(3,GL_FLOAT,0,C.p);
  //glNormalPointer(GL_DOUBLE,0,Vn.p);
    
  //triangles
  if(T.N) glDrawElements(GL_TRIANGLES,T.N,GL_UNSIGNED_INT,T.p);
  //strips
  for(j=0;j<strips.N;j++)
    glDrawElements(GL_TRIANGLE_STRIP,strips(j).N,GL_UNSIGNED_INT,strips(j).p);
#elif 1
  uint i,j;
  glBegin(GL_TRIANGLES);
  glShadeModel(GL_SMOOTH);							
  for(i=0;i<T.d0;i++){
    if(trinormals) glNormal3dv(Tn(i));
    if(!trinormals) glNormal3dv(Vn(Tvi(i,0)));
    if(colored) glColor3fv(C(Tvi(i,0)));
    glVertex3dv(V(Tvi(i,0)));
    if(!trinormals) glNormal3dv(Vn(Tvi(i,1)));
    if(colored) glColor3fv(C(Tvi(i,1)));
    glVertex3dv(V(Tvi(i,1)));
    if(!trinormals) glNormal3dv(Vn(Tvi(i,2)));
    if(colored) glColor3fv(C(Tvi(i,2)));
    glVertex3dv(V(Tvi(i,2)));
  }
  glEnd();
  for(j=0;j<strips.N;j++){
    glBegin(GL_TRIANGLE_STRIP);
    for(i=0;i<strips(j).N;i++){
      glNormal3dv(Vn(strips(j)(i)));
      if(colored) glColor3fv(C(strips(j)(i)));
      glVertex3dv(V (strips(j)(i)));
    }
    glEnd();
  }
#else
  glBegin(GL_TRIANGLES);
  glShadeModel(GL_SMOOTH);							
  for(int i=0;i<T.d0;i++){
      
    if(trinormals) glNormal3dv(Tn(i));
    if(!trinormals) glNormal3dv(Tn(i));//(Vn(Tni(i,0)));
    ////  if(colored) glColor3fv(C(Tvi(i,0)));
    glVertex3dv(V(Tvi(i,0)));
      
    if(trinormals) glNormal3dv(Tn(i));
    if(!trinormals) glNormal3dv(Tn(i));//glNormal3dv(Vn(Tni(i,1)));
    ////  if(colored) glColor3fv(C(Tvi(i,1)));
    glVertex3dv(V(Tvi(i,1)));
      
    if(trinormals) glNormal3dv(Tn(i));
    if(!trinormals) glNormal3dv(Tn(i));//glNormal3dv(Vn(Tni(i,2)));
    ////  if(colored) glColor3fv(C(Tvi(i,0)));
    glVertex3dv(V(Tvi(i,2)));
      
      
  }
  glEnd();
#endif
}
#endif
