
#if 1
#  define CALLBACK_DEBUG(x) x
#else
#  define CALLBACK_DEBUG(x)
#endif


//===========================================================================
//
// modified main loop routine
// only change to free glut: don't deinitialize the glut engine!
//

#if 1 || !defined MT_Cygwin
extern "C"{
#include "opengl_freeglut_modified.c"
}
#endif

//===========================================================================
//
// callbacks
//

int sequence_number = 0;

uint nrWins=0;

void getSphereVector(geo3d::Vector& vec,int _x,int _y){
  int width=glutGet(GLUT_WINDOW_WIDTH);
  int height=glutGet(GLUT_WINDOW_HEIGHT);
  int minwh = width<height?width:height;
  double x,y;
  x=(double)_x;  x=x-.5*width;  x*= 2./minwh;
  y=(double)_y;  y=y-.5*height; y*=-2./minwh;
  vec(0)=x;
  vec(1)=y;
  vec(2)=.5-(x*x+y*y);
  if(vec(2)<0.) vec(2)=0.;
}

void OpenGL::Reshape(int width, int height){
  CALLBACK_DEBUG(printf("%6d Window %d Reshape Callback:  %d %d\n", ++sequence_number, glutGetWindow(), width, height ));
  camera.setWHRatio((double)width/height);
  glutPostRedisplay();
}

void OpenGL::Key(unsigned char key, int x, int y){
  CALLBACK_DEBUG(printf("%6d Window %d Keyboard Callback:  %d %d %d\n", ++sequence_number, glutGetWindow(), key, x, y ));
  pressedkey=key;
  //glutPostRedisplay();
  glutLeaveMainLoop();
}

void Special(int key, int x, int y){
  CALLBACK_DEBUG(printf("%6d Window %d Special Key Callback:  %d %d %d\n", ++sequence_number, glutGetWindow(), key, x, y ));
  glutPostRedisplay();
}

void Visibility(int vis){
  CALLBACK_DEBUG(printf("%6d Window %d Visibility Callback:  %d\n", ++sequence_number, glutGetWindow(), vis ));
  glutPostRedisplay();
}

void KeyUp(unsigned char key, int x, int y){
  CALLBACK_DEBUG(printf("%6d Window %d Key Release Callback:  %d %d %d\n", ++sequence_number, glutGetWindow(), key, x, y ));
  glutPostRedisplay();
}

void SpecialUp(int key, int x, int y){
  CALLBACK_DEBUG(printf("%6d Window %d Special Key Release Callback:  %d %d %d\n", ++sequence_number, glutGetWindow(), key, x, y ));
  glutPostRedisplay();
}

void Joystick( unsigned int a, int b, int c, int d)  /* Need meaningful names */
{
  
  CALLBACK_DEBUG(printf("%6d Window %d Joystick Callback:  %d %d %d %d\n", ++sequence_number, glutGetWindow(), a, b, c, d ));
  glutPostRedisplay();
}

static geo3d::Vector downVec,downPos;
static geo3d::Rotation downRot;
static int mouse_button;

void OpenGL::Mouse(int button, int updown, int _x, int _y){
  CALLBACK_DEBUG(printf("%6d Window %d Mouse Click Callback:  %d %d %d %d\n", ++sequence_number, glutGetWindow(), button, updown, _x, _y ));
  mouse_button=button;
  geo3d::Vector vec;
  getSphereVector(vec,_x,_y);
  lastEvent.set(button,-1,updown,_x,_y,0.,0.);
  mouseposx=vec(0); mouseposy=vec(1);
  mouseposx=_x; mouseposy=_y;
  if(updown==0){
    downVec=vec;
    downRot=camera.f->r;
    downPos=camera.f->p - camera.foc;
  }
  if(button==0 && updown==0){ //down
   cout <<"left but down (" <<vec <<')' <<endl;
  }
  if(button==0 && updown==0){ //up
  }
  glutPostRedisplay();
  if(button==2 && updown==0){ //down
    glutLeaveMainLoop();
  }
}

void MouseWheel(int wheel_number, int direction, int x, int y){
  CALLBACK_DEBUG(printf("%6d Window %d Mouse Wheel Callback:  %d %d %d %d\n", ++sequence_number, glutGetWindow(), wheel_number, direction, x, y ));
  glutPostRedisplay();
}

void OpenGL::Motion(int _x, int _y){
  CALLBACK_DEBUG(printf("%6d Window %d Mouse Motion Callback:  %d %d\n", ++sequence_number, glutGetWindow(), _x, _y ));
  geo3d::Vector vec;
  getSphereVector(vec,_x,_y);
  lastEvent.set(mouse_button,-1,-1,_x,_y,vec(0)-downVec(0),vec(1)-downVec(1));
  mouseposx=vec(0); mouseposy=vec(1);
  mouseposx=_x; mouseposy=_y;
  if(mouse_button==0){
    geo3d::Rotation rot;
    if(downVec(2)<.1){
      rot.setDiff(vec,downVec);  //consider imaged shere rotation of mouse-move
    }else{
      rot.setVec((vec-downVec) ^ geo3d::Vector(0,0,1)); //consider only xy-mouse-move
    }
    rot = downRot * rot / downRot; //interpret rotation relative to current viewing
    camera.f->p = camera.foc + rot * downPos;   //rotate camera's position
    camera.f->r = rot * downRot;   //rotate camera's direction
    glutPostRedisplay();
  }
  if(mouse_button==1){
    double dy = vec(1) - downVec(1);
    if(dy<-.99) dy = -.99;
    camera.f->p = camera.foc + downPos / (dy+1.);
    glutPostRedisplay();
  }
  if(mouse_button==2){
    glutLeaveMainLoop();
  }
}

void OpenGL::PassiveMotion(int x, int y){
  CALLBACK_DEBUG(printf("%6d Window %d Mouse Passive Motion Callback:  %d %d\n", ++sequence_number, glutGetWindow(), x, y ));
  //glutPostRedisplay();
  mouseposx=x; mouseposy=y;
}

void Entry(int state){
  CALLBACK_DEBUG(printf("%6d Window %d Entry Callback:  %d\n", ++sequence_number, glutGetWindow(), state ));
  glutPostRedisplay();
}

void Close(void){
  CALLBACK_DEBUG(printf("%6d Window %d Close Callback\n", ++sequence_number, glutGetWindow() ));
}
